/*********************************
 * SGEngine.h
 *
 * Ce fichier vous est fourni selon les termes de la GNU General Public Licence V3 ou superieure
 * dont une copie est disponible  l'adresse suivante :
 * http://www.gnu.org/licenses/gpl.txt
 */


typedef struct level level;
typedef struct sprite8 sprite8;
typedef struct sprite16 sprite16;
typedef struct gBuffers gBuffers;
typedef struct player player;


struct level {
	unsigned char layer0[8][12];
	unsigned char objLayer[8][12];
};

struct sprite8 {
	unsigned char sprite0[8];
	unsigned char sprite1[8];
};

struct sprite16 {
	unsigned char sprite0[32];
	unsigned char sprite1[32];
};

struct gBuffers {
	unsigned char b0[1024];
	unsigned char b1[1024];
};

struct player {
	int curLevel;
	unsigned char posX, posY;
	unsigned char oldX, oldY;
	sprite8 sprtRight, sprtLeft, *curSprite;
	unsigned char carriedObj;
	unsigned int kUP, kLEFT, kRIGHT, kACTION, kQUIT;
};


void SGEMainLoop(player *plr, gBuffers *buffers, level world[], sprite8 sprtLayer0[], sprite8 sprtObjLayer[], sprite16 iBoard[]);
void drawLayer(unsigned char map[8][12], gBuffers *buffers, sprite8 sprites[]);
void drawPlayerSprite(player *plr, gBuffers *buffers);
void testKeys(player *plr, unsigned char *endloop, level world[], gBuffers *buffers, sprite8 sprtLayer0[], sprite8 sprtObjLayer[]);
void removePlayerSprite(player *plr, gBuffers *buffers, level world[], sprite8 sprtLayer0[], sprite8 sprtObjLayer[]);
char testLayerCollide(player *plr, unsigned char layer[8][12]);
unsigned char swapObj(player *plr, unsigned char map[8][12]);
void drawPlrObj(player *plr, gBuffers *buffers, sprite8 *sprites);
void drawBoard(player *plr, gBuffers *buffers, sprite16 iBoard[]);

