/*********************************
 *
 *  Sorcery G
 *  Une adaptation libre du jeu de Martin Wheeler
 *  Pour calculatrices Casio GRAPH 75, 85 et 95
 *  (c)2009 Tratak
 *  Le prsent logiciel vous est fourni selon les termes de la GNU General Public Licence V3 ou superieure
 */

/*********************************
 * SorceryG.c
 *
 * Ce fichier vous est fourni selon les termes de la GNU General Public Licence V3 ou superieure
 * dont une copie est disponible  l'adresse suivante :
 * http://www.gnu.org/licenses/gpl.txt
 */

#include <stdlib.h>
#include "fxlib.h"
#include "revolution.h"
#include "SGEngine.h"


/**************
 **** Main ****
 **************/

int AddIn_main(int isAppli, unsigned short OptionNum){
	
	
	// ***** Initialisation du monde *****
	
	level world[] = {{	{	0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0, // layer0
							0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 0, 1,
							0, 0, 0, 0, 3, 0, 0, 0, 0, 0, 4, 4,
							4, 4, 0, 0, 3, 0, 0, 0, 0, 0, 0, 0,
							0, 0, 0, 0, 2, 0, 0, 0, 0, 2, 0, 0,
							0, 0, 0, 0, 0, 0, 0, 2, 0, 3, 0, 0,
							1, 0, 0, 0, 0, 0, 0, 3, 0, 3, 0, 0,
							4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4
						},
									
						{	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, // objLayer
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 2, 0,
							0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
						}
	}};
	
	
	// ***** sprites *****

	sprite8 sprtLayer0[] = {	{	{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, // sprite vide
									{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}},  
								{	{0x18, 0x3C, 0x7E, 0xFF, 0xFF, 0xFD, 0xFF, 0xFF}, // porte
									{0x18, 0x3C, 0x7E, 0xFF, 0xFF, 0xFD, 0xFF, 0xFF}}, 
								{	{0x3C, 0x4E, 0x87, 0x87, 0x87, 0x87, 0x4E, 0x3C}, // boule
									{0x3C, 0x4E, 0x87, 0x87, 0x87, 0x87, 0x4E, 0x3C}}, 
								{	{0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C}, // barre verticale
									{0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x18, 0x3C}}, 
								{	{0xFF, 0x00, 0xFF, 0x00, 0x44, 0x11, 0x44, 0x11}, // sol
									{0xFF, 0x00, 0xFF, 0x00, 0x44, 0x11, 0x44, 0x11}}  
	}; 

	sprite8 sprtObjLayer[] = {	{	{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}, // sprite vide
									{0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}},  
								{	{0x18, 0x7E, 0x7E, 0x7E, 0x5E, 0x5E, 0x2C, 0x18}, // bouclier
									{0x18, 0x7E, 0x7E, 0x7E, 0x5E, 0x5E, 0x2C, 0x18}}, 
								{	{0x18, 0x24, 0x24, 0x18, 0x08, 0x08, 0x18, 0x08}, // clef
									{0x18, 0x24, 0x24, 0x18, 0x08, 0x08, 0x18, 0x08}}  
	}; 
	
	
	// ***** Initialisation du joueur *****
	
	player plr = {	0, 														// niveau dans lequel le joueur apparait
					56, 24,													// position initiale  l'ecran;
					0, 0,													// sauvegarde des coords avant deplacement
					{	{0x78, 0xE4, 0xAC, 0x3C, 0x3F, 0x3C, 0x7E, 0xFE}, 	// sprite vers la droite
						{0x78, 0xE4, 0xAC, 0x3C, 0x3F, 0x3C, 0x7E, 0xFE}},			
					{	{0x1E, 0x27, 0x35, 0x3C, 0xFC, 0x3C, 0x7E, 0x7F}, 	// sprite vers la gauche
						{0x1E, 0x27, 0x35, 0x3C, 0xFC, 0x3C, 0x7E, 0x7F}},
					NULL, 													// pointeur vers sprite courant
					0, 														// Objet transport
					KEY_CTRL_UP, KEY_CTRL_LEFT, KEY_CTRL_RIGHT, KEY_CTRL_OPTN, KEY_CTRL_MENU // definition des touches
	};

	
	// ***** Tableau score, energie etc. *****
	
	sprite16 iBoard[] = {{	{0x7F, 0xFF, 0xFF, 0xFF, 0xE0, 0x00, 0xE0, 0x00, 0xE0, 0x00, 0xE0, 0xCD, 0x61, 0x11, 0x20, 0x91, 0x10, 0x51, 0x11, 0x8D, 0x10, 0x00, 0x10, 0x88, 0x11, 0x55, 0x11, 0x55, 0x11, 0x55, 0x08, 0x88},
							{0x80, 0x00, 0xC0, 0x00, 0xDF, 0xFF, 0xC0, 0x00, 0xC0, 0x00, 0xC0, 0xCD, 0xC1, 0x11, 0xC0, 0x91, 0xE0, 0x51, 0xE1, 0x8D, 0xE0, 0x00, 0xE0, 0x88, 0xE1, 0x55, 0xE1, 0x55, 0xE1, 0x55, 0xF0, 0x88}},
						{	{0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x09, 0xD9, 0x09, 0x15, 0x09, 0x95, 0x09, 0x15, 0x09, 0xD5, 0x08, 0x00, 0x09, 0xFF, 0x09, 0xFF, 0x09, 0xFF, 0x09, 0xFF, 0x08, 0x00, 0x08, 0x00, 0x08, 0x00},
							{0xF0, 0x00, 0xF0, 0x00, 0xF0, 0x00, 0xF1, 0xD9, 0xF1, 0x15, 0xF1, 0x95, 0xF1, 0x15, 0xF1, 0xD5, 0xF0, 0x00, 0xF1, 0x00, 0xF1, 0x00, 0xF1, 0x00, 0xF1, 0x00, 0xF0, 0x00, 0xF0, 0x00, 0xF0, 0x00}},
						{	{0x10, 0x3B, 0x10, 0x11, 0x10, 0x11, 0x10, 0x11, 0x10, 0x13, 0x10, 0x00, 0x23, 0xFF, 0x23, 0xFF, 0x23, 0xFF, 0x23, 0xFF, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00},
							{0xE0, 0x3B, 0xE0, 0x11, 0xE0, 0x11, 0xE0, 0x11, 0xE0, 0x13, 0xE0, 0x00, 0xC2, 0x00, 0xC2, 0x00, 0xC2, 0x00, 0xC2, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00}},
						{	{0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x98, 0x00, 0xFC, 0x00, 0xFC, 0x00, 0xFC, 0x00, 0x7C, 0x00, 0x7C, 0x00, 0x1F, 0xFF},
							{0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0xFF, 0x3C, 0x00, 0x3C, 0x00, 0x1C, 0x00, 0x87, 0xFF, 0x84, 0x00, 0xF8, 0x00}},
						{	{0xFF, 0xF0, 0xFF, 0xF8, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0xD9, 0xC4, 0x55, 0x02, 0x59, 0x82, 0x55, 0x02, 0xD5, 0xC2, 0x00, 0x02, 0x88, 0x82, 0x55, 0x42, 0x55, 0x42, 0x55, 0x42, 0x88, 0x82},
							{0x00, 0x0F, 0x00, 0x07, 0xFF, 0xFB, 0x00, 0x03, 0x00, 0x03, 0xD9, 0xC3, 0x55, 0x01, 0x59, 0x81, 0x55, 0x01, 0xD5, 0xC1, 0x00, 0x01, 0x88, 0x81, 0x55, 0x41, 0x55, 0x41, 0x55, 0x41, 0x88, 0x81}},
						{	{0x00, 0x02, 0x00, 0x01, 0x00, 0x01, 0xD8, 0x95, 0x15, 0x55, 0x99, 0x09, 0x15, 0x49, 0xD4, 0xC9, 0x00, 0x01, 0xFF, 0xFD, 0xFF, 0xFD, 0xFF, 0xFD, 0xFF, 0xFD, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01},
							{0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0xD8, 0x94, 0x15, 0x54, 0x99, 0x08, 0x15, 0x48, 0xD4, 0xC8, 0x00, 0x00, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00}},
						{	{0xAB, 0x81, 0x3A, 0x01, 0x2B, 0x01, 0x2A, 0x01, 0xAB, 0x81, 0x00, 0x01, 0xFF, 0xF9, 0xFF, 0xF9, 0xFF, 0xFA, 0xFF, 0xFA, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x12, 0x00, 0x12},
							{0xAB, 0x80, 0x3A, 0x00, 0x2B, 0x00, 0x2A, 0x00, 0xAB, 0x80, 0x00, 0x00, 0x00, 0x08, 0x00, 0x08, 0x00, 0x09, 0x00, 0x09, 0x00, 0x01, 0x00, 0x01, 0x00, 0x01, 0x7F, 0xE1, 0x40, 0x21, 0x40, 0x21}},
						{	{0x00, 0x12, 0x00, 0x12, 0x00, 0x12, 0x00, 0x14, 0x00, 0x14, 0x00, 0x14, 0x00, 0x14, 0x3F, 0xF4, 0x00, 0x04, 0x00, 0x02, 0x00, 0x02, 0x00, 0x01, 0x00, 0x01, 0x78, 0x06, 0xFF, 0xFE, 0x87, 0xFC},
							{0x40, 0x21, 0x40, 0x21, 0x40, 0x21, 0x40, 0x21, 0x40, 0x23, 0x40, 0x23, 0x7F, 0xE3, 0x00, 0x03, 0x00, 0x03, 0xFE, 0x3D, 0x01, 0xC1, 0x00, 0x00, 0x78, 0x06, 0x87, 0xF9, 0x00, 0x01, 0x78, 0x03}}
	};
	
	// ***** Tampons graphiques *****

	gBuffers buffers;


	// *** boucle principale ***
	
	SGEMainLoop(&plr, &buffers, world, sprtLayer0, sprtObjLayer, iBoard);

	
	// *** sortie du programme ***
	
	return 1;
	
 }



/**********************
 **** blabla casio ****
 **********************/

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum) {
	return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
